# bdm::CsvFileDS Class Reference

CSV file data storage The constructor creates `Data` matrix from the records in a CSV file `fname`. The orientation can be of two types: 1. `BY_COL` which is default - the data are stored in columns; one column per time , one row per data item. 2. `BY_ROW` if the data are stored the classical CSV style. Then each column stores the values for data item, for ex. , one row for each discrete time instant. More...

`#include <datasources.h>`

List of all members.

## Public Member Functions
| CsvFileDS (const string &fname, const string &orientation="BY_COL")
| Constructor - create DS from a CSV file.
void | getdata (vec &dt)
| Returns full vector of observed data=[output, input].
void | getdata (vec &dt, const ivec &indices)
| Returns data records at indeces.
int | ndat ()
| returns number of data in the file;
void | log_add (logger &L)
| no sense to log this type
void | logit (logger &L)
| no sense to log this type
void | set_rvs (RV &drv, RV &urv)
void | write (vec &ut)
| Accepts action variable and schedule it for application.
void | write (vec &ut, ivec &indices)
virtual void | write (vec &ut, const ivec &indeces)
| Accepts action variables at specific indeces.
void | step ()
| Moves from to , i.e. perfroms the actions and reads response of the system.
virtual const RV & | _drv () const
| access function
const RV & | _urv () const
| access function
const RV & | _yrv () const
| access function
virtual void | set_drv (const RV &yrv, const RV &urv)
| set random variables
virtual string | to_string ()
| This method returns a basic info about the current instance.
virtual void | from_setting (const Setting &set)
| This method arrange instance properties according the data stored in the Setting structure.
virtual void | to_setting (Setting &set) const
| This method save all the instance properties into the Setting structure.
virtual void | validate ()
| This method TODO.
## Protected Attributes
mat | Data
| internal matrix of data
int | time
| active column in the Data matrix
ivec | rowid
| vector of rows that are presented in Dt
ivec | delays
| vector of delays that are presented in Dt
int | dtsize
| size of data returned by `getdata()`
int | utsize
| size of data
int | ytsize
| size of output
RV | Drv
| Description of data returned by `getdata()`.
RV | Urv
| Description of data witten by by `write()`.
RV | Yrv
| Description of output data.
int | L_dt
| Remember its own index in Logger L.
int | L_ut

## Detailed Description

CSV file data storage The constructor creates `Data` matrix from the records in a CSV file `fname`. The orientation can be of two types: 1. `BY_COL` which is default - the data are stored in columns; one column per time , one row per data item. 2. `BY_ROW` if the data are stored the classical CSV style. Then each column stores the values for data item, for ex. , one row for each discrete time instant.

The documentation for this class was generated from the following files:

- datasources.h
- datasources.cpp